`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    11:04:34 11/05/2018 
// Design Name: 
// Module Name:    FAFS 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module FAFS(SW1, SW2, SW3, SW4, LD1, LD2);
	input SW1, SW2, SW3, SW4;
	output LD1, LD2;
	
	wire S, Co, D, Bo;
	wire [1:0] O;
	
	FA U1(.A(SW1), .B(SW2), .Ci(SW3), .S(S), .Co(Co));
	FS U2(.A(SW1), .B(SW2), .Bi(SW3), .D(D), .Bo(Bo));
	
	assign O=SELECTOR({Co, S}, {Bo, D}, SW4);
	
	assign LD1 = ~O[0];
	assign LD2 = ~O[1];
	
	function [1:0]SELECTOR;
		input [1:0]D1;
		input [1:0]D2;
		input SW;
		begin
			if(SW == 0)
			begin
				SELECTOR=D1;
			end
			else
			begin
				SELECTOR=D2;
			end
		end
	endfunction

endmodule
